/// Data model about the page results from any paginated API
class PageData<T>{

  /// The list of data returned inside this page
  List<T> data;

  /// The status code results for this page
  int statusCode;

  /// Error message in case of error
  String errorMessage;

  /// Has a next page?
  bool hasNext;

  PageData({
    required this.data,
    required this.statusCode,
    required this.errorMessage,
    required this.hasNext
  });

}