/// IMPORTING THIRD PARTY PACKAGES
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

import 'providerState/providerState.dart';
import 'scrollCards/scrollCards.dart';

export 'providerState/providerState.dart';

/// The list details component with scroll cards and details component
class ListDetails<T, V> extends StatelessWidget{

  /// It gets the element with details about the selected item
  final Widget Function(T element) getDetailsElement;

  /// It gets the element inside the scroll cards
  final Widget Function(T element, bool isSelected) getScrollCard;

  ListDetails({Key? key,
    required this.getDetailsElement,
    required this.getScrollCard
  }): super(key: key);

  @override
  Widget build(BuildContext context) {
    return Consumer<ListDetailsProvideState<T>>(
        builder: (context, provider, child){
          return Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Expanded(
                child: SizedBox(
                  child: ScrollCards<T>(
                    getCard: (T element, bool isSelected) => this.getScrollCard(element, isSelected),
                  ),
                  height: 600,
                ),
              ),
              Expanded(
                child: this.getDetailsElement(provider.getCurrentElement),
                flex: 2,
              )
            ],
          );
        }
    );
  }



}

